#include <bindings.dsl.h>
#include <CoreFoundation/CFBase.h>

module Bindings.CoreFoundation.CFBase where
#strict_import

#integral_t Boolean
#integral_t UInt8
#integral_t SInt8
#integral_t UInt16
#integral_t SInt16
#integral_t UInt32
#integral_t SInt32
#integral_t UInt64
#integral_t SInt64
#integral_t OSStatus
#synonym_t  Float32, CFloat
#synonym_t  Float64, CDouble
#integral_t UniChar
#synonym_t  StringPtr       , Ptr CUChar
#synonym_t  ConstStringPtr  , Ptr CUChar
#synonym_t  Str255          , Ptr CUChar
#synonym_t  ConstStr255Param, Ptr CUChar
#integral_t OSErr
#integral_t RegionCode
#integral_t LangCode
#integral_t UTF32Char
#integral_t UTF16Char
#integral_t UTF8Char

#pointer NULL
#num     TRUE
#num     FALSE

#globalvar kCFCoreFoundationVersionNumber, CDouble
#fractional kCFCoreFoundationVersionNumber10_0
#fractional kCFCoreFoundationVersionNumber10_0_3
#fractional kCFCoreFoundationVersionNumber10_1
#fractional kCFCoreFoundationVersionNumber10_1_1
#fractional kCFCoreFoundationVersionNumber10_1_2
#fractional kCFCoreFoundationVersionNumber10_1_3
#fractional kCFCoreFoundationVersionNumber10_1_4
#fractional kCFCoreFoundationVersionNumber10_2
#fractional kCFCoreFoundationVersionNumber10_2_1
#fractional kCFCoreFoundationVersionNumber10_2_2
#fractional kCFCoreFoundationVersionNumber10_2_3
#fractional kCFCoreFoundationVersionNumber10_2_4
#fractional kCFCoreFoundationVersionNumber10_2_5
#fractional kCFCoreFoundationVersionNumber10_2_6
#fractional kCFCoreFoundationVersionNumber10_2_7
#fractional kCFCoreFoundationVersionNumber10_2_8
#fractional kCFCoreFoundationVersionNumber10_3
#fractional kCFCoreFoundationVersionNumber10_3_1
#fractional kCFCoreFoundationVersionNumber10_3_2
#fractional kCFCoreFoundationVersionNumber10_3_3
#fractional kCFCoreFoundationVersionNumber10_3_4
#fractional kCFCoreFoundationVersionNumber10_3_5
#fractional kCFCoreFoundationVersionNumber10_3_6
#fractional kCFCoreFoundationVersionNumber10_3_7
#fractional kCFCoreFoundationVersionNumber10_3_8
#fractional kCFCoreFoundationVersionNumber10_3_9
#fractional kCFCoreFoundationVersionNumber10_4
#fractional kCFCoreFoundationVersionNumber10_4_1
#fractional kCFCoreFoundationVersionNumber10_4_2
#fractional kCFCoreFoundationVersionNumber10_4_3
#fractional kCFCoreFoundationVersionNumber10_4_4_Intel
#fractional kCFCoreFoundationVersionNumber10_4_4_PowerPC
#fractional kCFCoreFoundationVersionNumber10_4_5_Intel
#fractional kCFCoreFoundationVersionNumber10_4_5_PowerPC
#fractional kCFCoreFoundationVersionNumber10_4_6_Intel
#fractional kCFCoreFoundationVersionNumber10_4_6_PowerPC
#fractional kCFCoreFoundationVersionNumber10_4_7
#fractional kCFCoreFoundationVersionNumber10_4_8
#fractional kCFCoreFoundationVersionNumber10_4_9
#fractional kCFCoreFoundationVersionNumber10_4_10
#fractional kCFCoreFoundationVersionNumber10_4_11

#integral_t CFTypeID
#integral_t CFOptionFlags
#integral_t CFHashCode
#integral_t CFIndex

#synonym_t CFTypeRef, Ptr ()

#opaque_t  __CFString
#synonym_t CFStringRef       , Ptr <__CFString>
#synonym_t CFMutableStringRef, Ptr <__CFString>

#synonym_t CFPropertyListRef , <CFTypeRef>
#num       kCFCompareLessThan
#num       kCFCompareEqualTo
#num       kCFCompareGreaterThan
#synonym_t CFComparisonResult, <CFIndex>

#callback CFComparatorFunction, Ptr () -> Ptr () -> Ptr () -> IO <CFComparisonResult>

#num kCFNotFound

#starttype CFRange
#  field location, <CFIndex>
#  field length  , <CFIndex>
#stoptype

#if MAC_OS_X_VERSION_10_2 <= MAC_OS_X_VERSION_MAX_ALLOWED
#  opaque_t  __CFNull
#  synonym_t CFNullRef      , Ptr <__CFNull>
#  ccall     CFNullGetTypeID, IO <CFTypeID>
#  cinline   kCFNull        , IO <CFNullRef>
#endif

#opaque_t  __CFAllocator
#synonym_t CFAllocatorRef           , Ptr <__CFAllocator>
#cinline   kCFAllocatorDefault      , IO <CFAllocatorRef>
#cinline   kCFAllocatorSystemDefault, IO <CFAllocatorRef>
#cinline   kCFAllocatorMalloc       , IO <CFAllocatorRef>
#cinline   kCFAllocatorMallocZone   , IO <CFAllocatorRef>
#cinline   kCFAllocatorNull         , IO <CFAllocatorRef>
#cinline   kCFAllocatorUseContext   , IO <CFAllocatorRef>

#callback CFAllocatorRetainCallBack         , Ptr () -> IO (Ptr ())
#callback CFAllocatorReleaseCallBack        , Ptr () -> IO ()
#callback CFAllocatorCopyDescriptionCallBack, Ptr () -> IO <CFStringRef>
#callback CFAllocatorAllocateCallBack       , <CFIndex> -> <CFOptionFlags> -> Ptr () -> IO (Ptr ())
#callback CFAllocatorReallocateCallBack     , Ptr () -> <CFIndex> -> <CFOptionFlags> -> Ptr () -> IO (Ptr ())
#callback CFAllocatorDeallocateCallBack     , Ptr () -> Ptr () -> IO ()
#callback CFAllocatorPreferredSizeCallBack  , <CFIndex> -> <CFOptionFlags> -> Ptr () -> IO <CFIndex>

#starttype CFAllocatorContext
#  field version        , <CFIndex>
#  field info           , Ptr ()
#  field retain         , <CFAllocatorRetainCallBack>
#  field release        , <CFAllocatorReleaseCallBack>
#  field copyDescription, <CFAllocatorCopyDescriptionCallBack>
#  field allocate       , <CFAllocatorAllocateCallBack>
#  field reallocate     , <CFAllocatorReallocateCallBack>
#  field deallocate     , <CFAllocatorDeallocateCallBack>
#  field preferredSize  , <CFAllocatorPreferredSizeCallBack>
#stoptype

#ccall CFAllocatorGetTypeID , IO <CFTypeID>
#ccall CFAllocatorSetDefault, <CFAllocatorRef> -> IO ()
#ccall CFAllocatorGetDefault, IO <CFAllocatorRef>
#ccall CFAllocatorCreate    , <CFAllocatorRef> -> Ptr <CFAllocatorContext> -> IO <CFAllocatorRef>
#ccall CFAllocatorAllocate  , <CFAllocatorRef> -> <CFIndex> -> <CFOptionFlags> -> IO (Ptr ())
#ccall CFAllocatorReallocate, <CFAllocatorRef> -> Ptr () -> <CFIndex> -> <CFOptionFlags> -> IO (Ptr ())
#ccall CFAllocatorDeallocate, <CFAllocatorRef> -> Ptr () -> IO ()
#ccall CFAllocatorGetPreferredSizeForSize, <CFAllocatorRef> -> <CFIndex> -> <CFOptionFlags> -> IO <CFIndex>
#ccall CFAllocatorGetContext, <CFAllocatorRef> -> Ptr <CFAllocatorContext> -> IO ()

#ccall CFGetTypeID      , <CFTypeRef> -> IO <CFTypeID>
#ccall CFCopyTypeIDDescription, <CFTypeID> -> IO <CFStringRef>
#ccall CFRetain         , <CFTypeRef> -> IO <CFTypeRef>
#ccall CFRelease        , <CFTypeRef> -> IO ()
#ccall CFGetRetainCount , <CFTypeRef> -> IO <CFIndex>
#ccall CFMakeCollectable, <CFTypeRef> -> IO <CFTypeRef>
#ccall CFEqual          , <CFTypeRef> -> <CFTypeRef> -> IO <Boolean>
#ccall CFHash           , <CFTypeRef> -> IO <CFHashCode>
#ccall CFCopyDescription, <CFTypeRef> -> IO <CFStringRef>
#ccall CFGetAllocator   , <CFTypeRef> -> IO <CFAllocatorRef>
