#include <bindings.dsl.h>
#include <CoreFoundation/CFLocale.h>

module Bindings.CoreFoundation.CFLocale where
#strict_import
import Bindings.CoreFoundation.CFArray
import Bindings.CoreFoundation.CFBase
import Bindings.CoreFoundation.CFDictionary

#if MAC_OS_X_VERSION_10_3 <= MAC_OS_X_VERSION_MAX_ALLOWED
#  opaque_t  __CFLocale
#  synonym_t CFLocaleRef, Ptr <__CFLocale>

#  ccall CFLocaleGetTypeID  , IO <CFTypeID>
#  ccall CFLocaleGetSystem  , IO <CFLocaleRef>
#  ccall CFLocaleCopyCurrent, IO <CFLocaleRef>
#  ccall CFLocaleCopyAvailableLocaleIdentifiers, IO <CFArrayRef>
#  ccall CFLocaleCopyISOLanguageCodes          , IO <CFArrayRef>
#  ccall CFLocaleCopyISOCountryCodes           , IO <CFArrayRef>
#  ccall CFLocaleCopyISOCurrencyCodes          , IO <CFArrayRef>
#  ccall CFLocaleCopyCommonISOCurrencyCodes    , IO <CFArrayRef>
#  ccall CFLocaleCopyPreferredLanguages        , IO <CFArrayRef>
#  ccall CFLocaleCreateCanonicalLanguageIdentifierFromString, <CFAllocatorRef> -> <CFStringRef> -> IO <CFStringRef>
#  ccall CFLocaleCreateCanonicalLocaleIdentifierFromString  , <CFAllocatorRef> -> <CFStringRef> -> IO <CFStringRef>
#  ccall CFLocaleCreateCanonicalLocaleIdentifierFromScriptManagerCodes, <CFAllocatorRef> -> <LangCode> -> <RegionCode> -> IO <CFStringRef>
#  ccall CFLocaleCreateComponentsFromLocaleIdentifier       , <CFAllocatorRef> -> <CFStringRef> -> IO <CFDictionaryRef>
#  ccall CFLocaleCreateLocaleIdentifierFromComponents       , <CFAllocatorRef> -> <CFDictionaryRef> -> IO <CFStringRef>
#  ccall CFLocaleCreate       , <CFAllocatorRef> -> <CFStringRef> -> IO <CFLocaleRef>
#  ccall CFLocaleCreateCopy   , <CFAllocatorRef> -> <CFLocaleRef> -> IO <CFLocaleRef>
#  ccall CFLocaleGetIdentifier, <CFLocaleRef> -> IO <CFStringRef>
#  ccall CFLocaleGetValue     , <CFLocaleRef> -> <CFStringRef> -> IO <CFTypeRef>
#  ccall CFLocaleCopyDisplayNameForPropertyValue, <CFLocaleRef> -> <CFStringRef> -> <CFStringRef> -> IO <CFStringRef>

#  cinline kCFLocaleCurrentLocaleDidChangeNotification, IO <CFStringRef>

#  cinline kCFLocaleIdentifier  , IO <CFStringRef>
#  cinline kCFLocaleLanguageCode, IO <CFStringRef>
#  cinline kCFLocaleCountryCode , IO <CFStringRef>
#  cinline kCFLocaleScriptCode  , IO <CFStringRef>
#  cinline kCFLocaleVariantCode , IO <CFStringRef>

#  cinline kCFLocaleExemplarCharacterSet, IO <CFStringRef>
#  cinline kCFLocaleCalendarIdentifier  , IO <CFStringRef>
#  cinline kCFLocaleCalendar            , IO <CFStringRef>
#  cinline kCFLocaleCollationIdentifier , IO <CFStringRef>
#  cinline kCFLocaleUsesMetricSystem    , IO <CFStringRef>
#  cinline kCFLocaleMeasurementSystem   , IO <CFStringRef>
#  cinline kCFLocaleDecimalSeparator    , IO <CFStringRef>
#  cinline kCFLocaleGroupingSeparator   , IO <CFStringRef>
#  cinline kCFLocaleCurrencySymbol      , IO <CFStringRef>
#  cinline kCFLocaleCurrencyCode        , IO <CFStringRef>

#  cinline kCFGregorianCalendar   , IO <CFStringRef>
#  cinline kCFBuddhistCalendar    , IO <CFStringRef>
#  cinline kCFChineseCalendar     , IO <CFStringRef>
#  cinline kCFHebrewCalendar      , IO <CFStringRef>
#  cinline kCFIslamicCalendar     , IO <CFStringRef>
#  cinline kCFIslamicCivilCalendar, IO <CFStringRef>
#  cinline kCFJapaneseCalendar    , IO <CFStringRef>
#endif
